Code

b16a9b98f454d34490f31d046f22967a8865a1ae
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48         my @env = keys %ENV;
49         my $ok = join("|", qw(
50                 TRACE
51                 DEBUG
52                 USE_LOOKUP
53                 TEST
54                 .*_TEST
55                 PROVE
56                 VALGRIND
57         ));
58         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59         print join("\n", @vars);
60 ')
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
65 GIT_MERGE_VERBOSITY=5
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
69 export EDITOR
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
73 unset CDPATH
75 unset GREP_OPTIONS
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
78         1|2|true)
79                 echo "* warning: Some tests will not work if GIT_TRACE" \
80                         "is set as to trace on STDERR ! *"
81                 echo "* warning: Please set GIT_TRACE to something" \
82                         "other than 1, 2 or true ! *"
83                 ;;
84 esac
86 # Convenience
87 #
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
92 # Zero SHA-1
93 _z40=0000000000000000000000000000000000000000
95 # Each test should start with something like this, after copyright notices:
96 #
97 # test_description='Description of this test...
98 # This test checks if command xyzzy does the right thing...
99 # '
100 # . ./test-lib.sh
101 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
102                 TERM=$ORIGINAL_TERM &&
103                 export TERM &&
104                 [ -t 1 ] &&
105                 tput bold >/dev/null 2>&1 &&
106                 tput setaf 1 >/dev/null 2>&1 &&
107                 tput sgr0 >/dev/null 2>&1
108         ) &&
109         color=t
111 while test "$#" -ne 0
112 do
113         case "$1" in
114         -d|--d|--de|--deb|--debu|--debug)
115                 debug=t; shift ;;
116         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117                 immediate=t; shift ;;
118         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
119                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
120         -h|--h|--he|--hel|--help)
121                 help=t; shift ;;
122         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
123                 verbose=t; shift ;;
124         -q|--q|--qu|--qui|--quie|--quiet)
125                 # Ignore --quiet under a TAP::Harness. Saying how many tests
126                 # passed without the ok/not ok details is always an error.
127                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
128         --with-dashes)
129                 with_dashes=t; shift ;;
130         --no-color)
131                 color=; shift ;;
132         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
133                 valgrind=t; verbose=t; shift ;;
134         --tee)
135                 shift ;; # was handled already
136         --root=*)
137                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
138                 shift ;;
139         *)
140                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
141         esac
142 done
144 if test -n "$color"; then
145         say_color () {
146                 (
147                 TERM=$ORIGINAL_TERM
148                 export TERM
149                 case "$1" in
150                         error) tput bold; tput setaf 1;; # bold red
151                         skip)  tput bold; tput setaf 2;; # bold green
152                         pass)  tput setaf 2;;            # green
153                         info)  tput setaf 3;;            # brown
154                         *) test -n "$quiet" && return;;
155                 esac
156                 shift
157                 printf "%s" "$*"
158                 tput sgr0
159                 echo
160                 )
161         }
162 else
163         say_color() {
164                 test -z "$1" && test -n "$quiet" && return
165                 shift
166                 echo "$*"
167         }
168 fi
170 error () {
171         say_color error "error: $*"
172         GIT_EXIT_OK=t
173         exit 1
176 say () {
177         say_color info "$*"
180 test "${test_description}" != "" ||
181 error "Test script did not set test_description."
183 if test "$help" = "t"
184 then
185         echo "$test_description"
186         exit 0
187 fi
189 exec 5>&1
190 if test "$verbose" = "t"
191 then
192         exec 4>&2 3>&1
193 else
194         exec 4>/dev/null 3>/dev/null
195 fi
197 test_failure=0
198 test_count=0
199 test_fixed=0
200 test_broken=0
201 test_success=0
203 test_external_has_tap=0
205 die () {
206         code=$?
207         if test -n "$GIT_EXIT_OK"
208         then
209                 exit $code
210         else
211                 echo >&5 "FATAL: Unexpected exit with code $code"
212                 exit 1
213         fi
216 GIT_EXIT_OK=
217 trap 'die' EXIT
219 # The semantics of the editor variables are that of invoking
220 # sh -c "$EDITOR \"$@\"" files ...
222 # If our trash directory contains shell metacharacters, they will be
223 # interpreted if we just set $EDITOR directly, so do a little dance with
224 # environment variables to work around this.
226 # In particular, quoting isn't enough, as the path may contain the same quote
227 # that we're using.
228 test_set_editor () {
229         FAKE_EDITOR="$1"
230         export FAKE_EDITOR
231         EDITOR='"$FAKE_EDITOR"'
232         export EDITOR
235 test_decode_color () {
236         awk '
237                 function name(n) {
238                         if (n == 0) return "RESET";
239                         if (n == 1) return "BOLD";
240                         if (n == 30) return "BLACK";
241                         if (n == 31) return "RED";
242                         if (n == 32) return "GREEN";
243                         if (n == 33) return "YELLOW";
244                         if (n == 34) return "BLUE";
245                         if (n == 35) return "MAGENTA";
246                         if (n == 36) return "CYAN";
247                         if (n == 37) return "WHITE";
248                         if (n == 40) return "BLACK";
249                         if (n == 41) return "BRED";
250                         if (n == 42) return "BGREEN";
251                         if (n == 43) return "BYELLOW";
252                         if (n == 44) return "BBLUE";
253                         if (n == 45) return "BMAGENTA";
254                         if (n == 46) return "BCYAN";
255                         if (n == 47) return "BWHITE";
256                 }
257                 {
258                         while (match($0, /\033\[[0-9;]*m/) != 0) {
259                                 printf "%s<", substr($0, 1, RSTART-1);
260                                 codes = substr($0, RSTART+2, RLENGTH-3);
261                                 if (length(codes) == 0)
262                                         printf "%s", name(0)
263                                 else {
264                                         n = split(codes, ary, ";");
265                                         sep = "";
266                                         for (i = 1; i <= n; i++) {
267                                                 printf "%s%s", sep, name(ary[i]);
268                                                 sep = ";"
269                                         }
270                                 }
271                                 printf ">";
272                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
273                         }
274                         print
275                 }
276         '
279 nul_to_q () {
280         perl -pe 'y/\000/Q/'
283 q_to_nul () {
284         perl -pe 'y/Q/\000/'
287 q_to_cr () {
288         tr Q '\015'
291 q_to_tab () {
292         tr Q '\011'
295 append_cr () {
296         sed -e 's/$/Q/' | tr Q '\015'
299 remove_cr () {
300         tr '\015' Q | sed -e 's/Q$//'
303 # In some bourne shell implementations, the "unset" builtin returns
304 # nonzero status when a variable to be unset was not set in the first
305 # place.
307 # Use sane_unset when that should not be considered an error.
309 sane_unset () {
310         unset "$@"
311         return 0
314 test_tick () {
315         if test -z "${test_tick+set}"
316         then
317                 test_tick=1112911993
318         else
319                 test_tick=$(($test_tick + 60))
320         fi
321         GIT_COMMITTER_DATE="$test_tick -0700"
322         GIT_AUTHOR_DATE="$test_tick -0700"
323         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
326 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
328 # This will commit a file with the given contents and the given commit
329 # message.  It will also add a tag with <message> as name.
331 # Both <file> and <contents> default to <message>.
333 test_commit () {
334         file=${2:-"$1.t"}
335         echo "${3-$1}" > "$file" &&
336         git add "$file" &&
337         test_tick &&
338         git commit -m "$1" &&
339         git tag "$1"
342 # Call test_merge with the arguments "<message> <commit>", where <commit>
343 # can be a tag pointing to the commit-to-merge.
345 test_merge () {
346         test_tick &&
347         git merge -m "$1" "$2" &&
348         git tag "$1"
351 # This function helps systems where core.filemode=false is set.
352 # Use it instead of plain 'chmod +x' to set or unset the executable bit
353 # of a file in the working directory and add it to the index.
355 test_chmod () {
356         chmod "$@" &&
357         git update-index --add "--chmod=$@"
360 # Use test_set_prereq to tell that a particular prerequisite is available.
361 # The prerequisite can later be checked for in two ways:
363 # - Explicitly using test_have_prereq.
365 # - Implicitly by specifying the prerequisite tag in the calls to
366 #   test_expect_{success,failure,code}.
368 # The single parameter is the prerequisite tag (a simple word, in all
369 # capital letters by convention).
371 test_set_prereq () {
372         satisfied="$satisfied$1 "
374 satisfied=" "
376 test_have_prereq () {
377         # prerequisites can be concatenated with ','
378         save_IFS=$IFS
379         IFS=,
380         set -- $*
381         IFS=$save_IFS
383         total_prereq=0
384         ok_prereq=0
385         missing_prereq=
387         for prerequisite
388         do
389                 total_prereq=$(($total_prereq + 1))
390                 case $satisfied in
391                 *" $prerequisite "*)
392                         ok_prereq=$(($ok_prereq + 1))
393                         ;;
394                 *)
395                         # Keep a list of missing prerequisites
396                         if test -z "$missing_prereq"
397                         then
398                                 missing_prereq=$prerequisite
399                         else
400                                 missing_prereq="$prerequisite,$missing_prereq"
401                         fi
402                 esac
403         done
405         test $total_prereq = $ok_prereq
408 test_declared_prereq () {
409         case ",$test_prereq," in
410         *,$1,*)
411                 return 0
412                 ;;
413         esac
414         return 1
417 # You are not expected to call test_ok_ and test_failure_ directly, use
418 # the text_expect_* functions instead.
420 test_ok_ () {
421         test_success=$(($test_success + 1))
422         say_color "" "ok $test_count - $@"
425 test_failure_ () {
426         test_failure=$(($test_failure + 1))
427         say_color error "not ok - $test_count $1"
428         shift
429         echo "$@" | sed -e 's/^/#       /'
430         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
433 test_known_broken_ok_ () {
434         test_fixed=$(($test_fixed+1))
435         say_color "" "ok $test_count - $@ # TODO known breakage"
438 test_known_broken_failure_ () {
439         test_broken=$(($test_broken+1))
440         say_color skip "not ok $test_count - $@ # TODO known breakage"
443 test_debug () {
444         test "$debug" = "" || eval "$1"
447 test_run_ () {
448         test_cleanup=:
449         expecting_failure=$2
450         eval >&3 2>&4 "$1"
451         eval_ret=$?
453         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
454         then
455                 eval >&3 2>&4 "$test_cleanup"
456         fi
457         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
458                 echo ""
459         fi
460         return "$eval_ret"
463 test_skip () {
464         test_count=$(($test_count+1))
465         to_skip=
466         for skp in $GIT_SKIP_TESTS
467         do
468                 case $this_test.$test_count in
469                 $skp)
470                         to_skip=t
471                         break
472                 esac
473         done
474         if test -z "$to_skip" && test -n "$test_prereq" &&
475            ! test_have_prereq "$test_prereq"
476         then
477                 to_skip=t
478         fi
479         case "$to_skip" in
480         t)
481                 of_prereq=
482                 if test "$missing_prereq" != "$test_prereq"
483                 then
484                         of_prereq=" of $test_prereq"
485                 fi
487                 say_color skip >&3 "skipping test: $@"
488                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
489                 : true
490                 ;;
491         *)
492                 false
493                 ;;
494         esac
497 test_expect_failure () {
498         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
499         test "$#" = 2 ||
500         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
501         export test_prereq
502         if ! test_skip "$@"
503         then
504                 say >&3 "checking known breakage: $2"
505                 if test_run_ "$2" expecting_failure
506                 then
507                         test_known_broken_ok_ "$1"
508                 else
509                         test_known_broken_failure_ "$1"
510                 fi
511         fi
512         echo >&3 ""
515 test_expect_success () {
516         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
517         test "$#" = 2 ||
518         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
519         export test_prereq
520         if ! test_skip "$@"
521         then
522                 say >&3 "expecting success: $2"
523                 if test_run_ "$2"
524                 then
525                         test_ok_ "$1"
526                 else
527                         test_failure_ "$@"
528                 fi
529         fi
530         echo >&3 ""
533 # test_external runs external test scripts that provide continuous
534 # test output about their progress, and succeeds/fails on
535 # zero/non-zero exit code.  It outputs the test output on stdout even
536 # in non-verbose mode, and announces the external script with "# run
537 # <n>: ..." before running it.  When providing relative paths, keep in
538 # mind that all scripts run in "trash directory".
539 # Usage: test_external description command arguments...
540 # Example: test_external 'Perl API' perl ../path/to/test.pl
541 test_external () {
542         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
543         test "$#" = 3 ||
544         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
545         descr="$1"
546         shift
547         export test_prereq
548         if ! test_skip "$descr" "$@"
549         then
550                 # Announce the script to reduce confusion about the
551                 # test output that follows.
552                 say_color "" "# run $test_count: $descr ($*)"
553                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
554                 # to be able to use them in script
555                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
556                 # Run command; redirect its stderr to &4 as in
557                 # test_run_, but keep its stdout on our stdout even in
558                 # non-verbose mode.
559                 "$@" 2>&4
560                 if [ "$?" = 0 ]
561                 then
562                         if test $test_external_has_tap -eq 0; then
563                                 test_ok_ "$descr"
564                         else
565                                 say_color "" "# test_external test $descr was ok"
566                                 test_success=$(($test_success + 1))
567                         fi
568                 else
569                         if test $test_external_has_tap -eq 0; then
570                                 test_failure_ "$descr" "$@"
571                         else
572                                 say_color error "# test_external test $descr failed: $@"
573                                 test_failure=$(($test_failure + 1))
574                         fi
575                 fi
576         fi
579 # Like test_external, but in addition tests that the command generated
580 # no output on stderr.
581 test_external_without_stderr () {
582         # The temporary file has no (and must have no) security
583         # implications.
584         tmp=${TMPDIR:-/tmp}
585         stderr="$tmp/git-external-stderr.$$.tmp"
586         test_external "$@" 4> "$stderr"
587         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
588         descr="no stderr: $1"
589         shift
590         say >&3 "# expecting no stderr from previous command"
591         if [ ! -s "$stderr" ]; then
592                 rm "$stderr"
594                 if test $test_external_has_tap -eq 0; then
595                         test_ok_ "$descr"
596                 else
597                         say_color "" "# test_external_without_stderr test $descr was ok"
598                         test_success=$(($test_success + 1))
599                 fi
600         else
601                 if [ "$verbose" = t ]; then
602                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
603                 else
604                         output=
605                 fi
606                 # rm first in case test_failure exits.
607                 rm "$stderr"
608                 if test $test_external_has_tap -eq 0; then
609                         test_failure_ "$descr" "$@" "$output"
610                 else
611                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
612                         test_failure=$(($test_failure + 1))
613                 fi
614         fi
617 # debugging-friendly alternatives to "test [-f|-d|-e]"
618 # The commands test the existence or non-existence of $1. $2 can be
619 # given to provide a more precise diagnosis.
620 test_path_is_file () {
621         if ! [ -f "$1" ]
622         then
623                 echo "File $1 doesn't exist. $*"
624                 false
625         fi
628 test_path_is_dir () {
629         if ! [ -d "$1" ]
630         then
631                 echo "Directory $1 doesn't exist. $*"
632                 false
633         fi
636 test_path_is_missing () {
637         if [ -e "$1" ]
638         then
639                 echo "Path exists:"
640                 ls -ld "$1"
641                 if [ $# -ge 1 ]; then
642                         echo "$*"
643                 fi
644                 false
645         fi
648 # test_line_count checks that a file has the number of lines it
649 # ought to. For example:
651 #       test_expect_success 'produce exactly one line of output' '
652 #               do something >output &&
653 #               test_line_count = 1 output
654 #       '
656 # is like "test $(wc -l <output) = 1" except that it passes the
657 # output through when the number of lines is wrong.
659 test_line_count () {
660         if test $# != 3
661         then
662                 error "bug in the test script: not 3 parameters to test_line_count"
663         elif ! test $(wc -l <"$3") "$1" "$2"
664         then
665                 echo "test_line_count: line count for $3 !$1 $2"
666                 cat "$3"
667                 return 1
668         fi
671 # This is not among top-level (test_expect_success | test_expect_failure)
672 # but is a prefix that can be used in the test script, like:
674 #       test_expect_success 'complain and die' '
675 #           do something &&
676 #           do something else &&
677 #           test_must_fail git checkout ../outerspace
678 #       '
680 # Writing this as "! git checkout ../outerspace" is wrong, because
681 # the failure could be due to a segv.  We want a controlled failure.
683 test_must_fail () {
684         "$@"
685         exit_code=$?
686         if test $exit_code = 0; then
687                 echo >&2 "test_must_fail: command succeeded: $*"
688                 return 1
689         elif test $exit_code -gt 129 -a $exit_code -le 192; then
690                 echo >&2 "test_must_fail: died by signal: $*"
691                 return 1
692         elif test $exit_code = 127; then
693                 echo >&2 "test_must_fail: command not found: $*"
694                 return 1
695         fi
696         return 0
699 # Similar to test_must_fail, but tolerates success, too.  This is
700 # meant to be used in contexts like:
702 #       test_expect_success 'some command works without configuration' '
703 #               test_might_fail git config --unset all.configuration &&
704 #               do something
705 #       '
707 # Writing "git config --unset all.configuration || :" would be wrong,
708 # because we want to notice if it fails due to segv.
710 test_might_fail () {
711         "$@"
712         exit_code=$?
713         if test $exit_code -gt 129 -a $exit_code -le 192; then
714                 echo >&2 "test_might_fail: died by signal: $*"
715                 return 1
716         elif test $exit_code = 127; then
717                 echo >&2 "test_might_fail: command not found: $*"
718                 return 1
719         fi
720         return 0
723 # Similar to test_must_fail and test_might_fail, but check that a
724 # given command exited with a given exit code. Meant to be used as:
726 #       test_expect_success 'Merge with d/f conflicts' '
727 #               test_expect_code 1 git merge "merge msg" B master
728 #       '
730 test_expect_code () {
731         want_code=$1
732         shift
733         "$@"
734         exit_code=$?
735         if test $exit_code = $want_code
736         then
737                 return 0
738         fi
740         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
741         return 1
744 # test_cmp is a helper function to compare actual and expected output.
745 # You can use it like:
747 #       test_expect_success 'foo works' '
748 #               echo expected >expected &&
749 #               foo >actual &&
750 #               test_cmp expected actual
751 #       '
753 # This could be written as either "cmp" or "diff -u", but:
754 # - cmp's output is not nearly as easy to read as diff -u
755 # - not all diff versions understand "-u"
757 test_cmp() {
758         $GIT_TEST_CMP "$@"
761 # This function can be used to schedule some commands to be run
762 # unconditionally at the end of the test to restore sanity:
764 #       test_expect_success 'test core.capslock' '
765 #               git config core.capslock true &&
766 #               test_when_finished "git config --unset core.capslock" &&
767 #               hello world
768 #       '
770 # That would be roughly equivalent to
772 #       test_expect_success 'test core.capslock' '
773 #               git config core.capslock true &&
774 #               hello world
775 #               git config --unset core.capslock
776 #       '
778 # except that the greeting and config --unset must both succeed for
779 # the test to pass.
781 # Note that under --immediate mode, no clean-up is done to help diagnose
782 # what went wrong.
784 test_when_finished () {
785         test_cleanup="{ $*
786                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
789 # Most tests can use the created repository, but some may need to create more.
790 # Usage: test_create_repo <directory>
791 test_create_repo () {
792         test "$#" = 1 ||
793         error "bug in the test script: not 1 parameter to test-create-repo"
794         repo="$1"
795         mkdir -p "$repo"
796         (
797                 cd "$repo" || error "Cannot setup test environment"
798                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
799                 error "cannot run git init -- have you built things yet?"
800                 mv .git/hooks .git/hooks-disabled
801         ) || exit
804 test_done () {
805         GIT_EXIT_OK=t
807         if test -z "$HARNESS_ACTIVE"; then
808                 test_results_dir="$TEST_DIRECTORY/test-results"
809                 mkdir -p "$test_results_dir"
810                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
812                 cat >>"$test_results_path" <<-EOF
813                 total $test_count
814                 success $test_success
815                 fixed $test_fixed
816                 broken $test_broken
817                 failed $test_failure
819                 EOF
820         fi
822         if test "$test_fixed" != 0
823         then
824                 say_color pass "# fixed $test_fixed known breakage(s)"
825         fi
826         if test "$test_broken" != 0
827         then
828                 say_color error "# still have $test_broken known breakage(s)"
829                 msg="remaining $(($test_count-$test_broken)) test(s)"
830         else
831                 msg="$test_count test(s)"
832         fi
833         case "$test_failure" in
834         0)
835                 # Maybe print SKIP message
836                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
838                 if test $test_external_has_tap -eq 0; then
839                         say_color pass "# passed all $msg"
840                         say "1..$test_count$skip_all"
841                 fi
843                 test -d "$remove_trash" &&
844                 cd "$(dirname "$remove_trash")" &&
845                 rm -rf "$(basename "$remove_trash")"
847                 exit 0 ;;
849         *)
850                 if test $test_external_has_tap -eq 0; then
851                         say_color error "# failed $test_failure among $msg"
852                         say "1..$test_count"
853                 fi
855                 exit 1 ;;
857         esac
860 # Test the binaries we have just built.  The tests are kept in
861 # t/ subdirectory and are run in 'trash directory' subdirectory.
862 if test -z "$TEST_DIRECTORY"
863 then
864         # We allow tests to override this, in case they want to run tests
865         # outside of t/, e.g. for running tests on the test library
866         # itself.
867         TEST_DIRECTORY=$(pwd)
868 fi
869 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
871 if test -n "$valgrind"
872 then
873         make_symlink () {
874                 test -h "$2" &&
875                 test "$1" = "$(readlink "$2")" || {
876                         # be super paranoid
877                         if mkdir "$2".lock
878                         then
879                                 rm -f "$2" &&
880                                 ln -s "$1" "$2" &&
881                                 rm -r "$2".lock
882                         else
883                                 while test -d "$2".lock
884                                 do
885                                         say "Waiting for lock on $2."
886                                         sleep 1
887                                 done
888                         fi
889                 }
890         }
892         make_valgrind_symlink () {
893                 # handle only executables, unless they are shell libraries that
894                 # need to be in the exec-path.  We will just use "#!" as a
895                 # guess for a shell-script, since we have no idea what the user
896                 # may have configured as the shell path.
897                 test -x "$1" ||
898                 test "#!" = "$(head -c 2 <"$1")" ||
899                 return;
901                 base=$(basename "$1")
902                 symlink_target=$GIT_BUILD_DIR/$base
903                 # do not override scripts
904                 if test -x "$symlink_target" &&
905                     test ! -d "$symlink_target" &&
906                     test "#!" != "$(head -c 2 < "$symlink_target")"
907                 then
908                         symlink_target=../valgrind.sh
909                 fi
910                 case "$base" in
911                 *.sh|*.perl)
912                         symlink_target=../unprocessed-script
913                 esac
914                 # create the link, or replace it if it is out of date
915                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
916         }
918         # override all git executables in TEST_DIRECTORY/..
919         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
920         mkdir -p "$GIT_VALGRIND"/bin
921         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
922         do
923                 make_valgrind_symlink $file
924         done
925         OLDIFS=$IFS
926         IFS=:
927         for path in $PATH
928         do
929                 ls "$path"/git-* 2> /dev/null |
930                 while read file
931                 do
932                         make_valgrind_symlink "$file"
933                 done
934         done
935         IFS=$OLDIFS
936         PATH=$GIT_VALGRIND/bin:$PATH
937         GIT_EXEC_PATH=$GIT_VALGRIND/bin
938         export GIT_VALGRIND
939 elif test -n "$GIT_TEST_INSTALLED" ; then
940         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
941         error "Cannot run git from $GIT_TEST_INSTALLED."
942         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
943         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
944 else # normal case, use ../bin-wrappers only unless $with_dashes:
945         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
946         if ! test -x "$git_bin_dir/git" ; then
947                 if test -z "$with_dashes" ; then
948                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
949                 fi
950                 with_dashes=t
951         fi
952         PATH="$git_bin_dir:$PATH"
953         GIT_EXEC_PATH=$GIT_BUILD_DIR
954         if test -n "$with_dashes" ; then
955                 PATH="$GIT_BUILD_DIR:$PATH"
956         fi
957 fi
958 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
959 unset GIT_CONFIG
960 GIT_CONFIG_NOSYSTEM=1
961 GIT_ATTR_NOSYSTEM=1
962 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
964 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
966 if test -z "$GIT_TEST_CMP"
967 then
968         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
969         then
970                 GIT_TEST_CMP="$DIFF -c"
971         else
972                 GIT_TEST_CMP="$DIFF -u"
973         fi
974 fi
976 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
977 export GITPERLLIB
978 test -d "$GIT_BUILD_DIR"/templates/blt || {
979         error "You haven't built things yet, have you?"
982 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
983 then
984         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
985         export GITPYTHONLIB
986         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
987                 error "You haven't built git_remote_helpers yet, have you?"
988         }
989 fi
991 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
992         echo >&2 'You need to build test-chmtime:'
993         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
994         exit 1
995 fi
997 # Test repository
998 test="trash directory.$(basename "$0" .sh)"
999 test -n "$root" && test="$root/$test"
1000 case "$test" in
1001 /*) TRASH_DIRECTORY="$test" ;;
1002  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1003 esac
1004 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1005 rm -fr "$test" || {
1006         GIT_EXIT_OK=t
1007         echo >&5 "FATAL: Cannot prepare test area"
1008         exit 1
1011 HOME="$TRASH_DIRECTORY"
1012 export HOME
1014 test_create_repo "$test"
1015 # Use -P to resolve symlinks in our working directory so that the cwd
1016 # in subprocesses like git equals our $PWD (for pathname comparisons).
1017 cd -P "$test" || exit 1
1019 this_test=${0##*/}
1020 this_test=${this_test%%-*}
1021 for skp in $GIT_SKIP_TESTS
1022 do
1023         case "$this_test" in
1024         $skp)
1025                 say_color skip >&3 "skipping test $this_test altogether"
1026                 skip_all="skip all tests in $this_test"
1027                 test_done
1028         esac
1029 done
1031 # Provide an implementation of the 'yes' utility
1032 yes () {
1033         if test $# = 0
1034         then
1035                 y=y
1036         else
1037                 y="$*"
1038         fi
1040         while echo "$y"
1041         do
1042                 :
1043         done
1046 # Fix some commands on Windows
1047 case $(uname -s) in
1048 *MINGW*)
1049         # Windows has its own (incompatible) sort and find
1050         sort () {
1051                 /usr/bin/sort "$@"
1052         }
1053         find () {
1054                 /usr/bin/find "$@"
1055         }
1056         sum () {
1057                 md5sum "$@"
1058         }
1059         # git sees Windows-style pwd
1060         pwd () {
1061                 builtin pwd -W
1062         }
1063         # no POSIX permissions
1064         # backslashes in pathspec are converted to '/'
1065         # exec does not inherit the PID
1066         test_set_prereq MINGW
1067         test_set_prereq SED_STRIPS_CR
1068         ;;
1069 *CYGWIN*)
1070         test_set_prereq POSIXPERM
1071         test_set_prereq EXECKEEPSPID
1072         test_set_prereq NOT_MINGW
1073         test_set_prereq SED_STRIPS_CR
1074         ;;
1075 *)
1076         test_set_prereq POSIXPERM
1077         test_set_prereq BSLASHPSPEC
1078         test_set_prereq EXECKEEPSPID
1079         test_set_prereq NOT_MINGW
1080         ;;
1081 esac
1083 test -z "$NO_PERL" && test_set_prereq PERL
1084 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1085 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1087 # Can we rely on git's output in the C locale?
1088 if test -n "$GETTEXT_POISON"
1089 then
1090         GIT_GETTEXT_POISON=YesPlease
1091         export GIT_GETTEXT_POISON
1092 else
1093         test_set_prereq C_LOCALE_OUTPUT
1094 fi
1096 # Use this instead of test_cmp to compare files that contain expected and
1097 # actual output from git commands that can be translated.  When running
1098 # under GETTEXT_POISON this pretends that the command produced expected
1099 # results.
1100 test_i18ncmp () {
1101         test -n "$GETTEXT_POISON" || test_cmp "$@"
1104 # Use this instead of "grep expected-string actual" to see if the
1105 # output from a git command that can be translated either contains an
1106 # expected string, or does not contain an unwanted one.  When running
1107 # under GETTEXT_POISON this pretends that the command produced expected
1108 # results.
1109 test_i18ngrep () {
1110         if test -n "$GETTEXT_POISON"
1111         then
1112             : # pretend success
1113         elif test "x!" = "x$1"
1114         then
1115                 shift
1116                 ! grep "$@"
1117         else
1118                 grep "$@"
1119         fi
1122 # test whether the filesystem supports symbolic links
1123 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1124 rm -f y
1126 # When the tests are run as root, permission tests will report that
1127 # things are writable when they shouldn't be.
1128 test -w / || test_set_prereq SANITY